/* arbol_binario_busqueda.c */

#include "arbol_binario_busqueda.h"

nodo_arbol *crear_nodo(tipo_clave entrada) {
nodo_arbol *punt;
  punt = malloc (sizeof(nodo_arbol));
  if (punt != NULL) {
    punt->clave = entrada;
    punt->izq = punt->der = NULL;
  } /* if ... */
  return punt;          
} /* crear_nodo */

nodo_arbol *buscar_clave(nodo_arbol *punt_a_buscar, tipo_clave a_buscar) {

  while (punt_a_buscar != NULL) { /* No hemos llegado al final del rbol (hoja) */
    if (punt_a_buscar->clave == a_buscar)
      break; /* equivale a return punt_a_buscar; */
    else if (punt_a_buscar->clave < a_buscar)
      punt_a_buscar = punt_a_buscar->der;
    else /* (punt_a_buscar->clave > a_buscar) */
      punt_a_buscar = punt_a_buscar->izq;  
  } /* while */
  return punt_a_buscar; /* Si encontrado, puntero a clave. En caso contrario NULL */      
} /* buscar_clave */

void insertar_clave_recur(nodo_arbol **punt_a_buscar, tipo_clave a_insertar) {

  if (*punt_a_buscar == NULL)
    *punt_a_buscar = crear_nodo(a_insertar);
  else
    if ((*punt_a_buscar)->clave == a_insertar) /* error clave repetida */
      return;
    else if ((*punt_a_buscar)->clave < a_insertar)
      insertar_clave_recur(&((*punt_a_buscar)->der), a_insertar);
    else /* ((*punt_a_buscar)->clave > a_insertar) */
      insertar_clave_recur(&((*punt_a_buscar)->izq), a_insertar);
} /* insertar_clave_recur */

int insertar_clave(nodo_arbol **punt_a_buscar, tipo_clave a_insertar) {

  /* printf("Entrada insertar clave %3d\n", a_insertar); */
  while (*punt_a_buscar != NULL) {
    if ((*punt_a_buscar)->clave == a_insertar) /* error clave repetida */
      return 0;
    else if ((*punt_a_buscar)->clave < a_insertar)
      punt_a_buscar = &((*punt_a_buscar)->der);
    else /* ((*punt_a_buscar)->clave > a_insertar) */
      punt_a_buscar = &((*punt_a_buscar)->izq);  
  } /* while */
  /* printf("Final insertar clave antes de crear_nodo %3d\n", a_insertar); */
  *punt_a_buscar = crear_nodo(a_insertar);
  return 1;
} /* insertar_clave */

void reemplazar(nodo_arbol **punt_a_buscar, nodo_arbol **punt_a_liberar) {
  if ((*punt_a_buscar)->izq == NULL) {
    (*punt_a_liberar)->clave = (*punt_a_buscar)->clave;
    *punt_a_liberar = *punt_a_buscar;
    *punt_a_buscar = (*punt_a_buscar)->der;
  } /* if */
  else
    reemplazar(&((*punt_a_buscar)->izq), punt_a_liberar);
  /* recursividad por la cola. Se puede sustituir por while */
  /*
    while ((*punt_a_buscar)->izq != NULL) 
      punt_a_buscar = &((*punt_a_buscar)->izq);
   
    (*punt_a_liberar)->clave = (*punt_a_buscar)->clave;
    *punt_a_liberar = *punt_a_buscar;
    *punt_a_buscar = (*punt_a_buscar)->der; 
  */
} /* reemplazar */

void borrar_clave_recur(nodo_arbol **punt_a_buscar, tipo_clave a_borrar) {
nodo_arbol *punt_aux;
    
  if (*punt_a_buscar == NULL)
    return;
  
  if ((*punt_a_buscar)->clave < a_borrar)
    borrar_clave_recur(&((*punt_a_buscar)->der), a_borrar);
  else if ((*punt_a_buscar)->clave > a_borrar)
    borrar_clave_recur(&((*punt_a_buscar)->izq), a_borrar);
  else /* ((*punt_a_buscar)->clave == a_borrar) */ {
    punt_aux = *punt_a_buscar;
    if ((*punt_a_buscar)->izq == NULL)
      *punt_a_buscar = (*punt_a_buscar)->der;      
    else if ((*punt_a_buscar)->der == NULL)
      *punt_a_buscar = (*punt_a_buscar)->izq;
    else /* ((*punt_a_buscar)->der != NULL) */ /* Buscamos clave menor de las mayores */
      reemplazar(&((*punt_a_buscar)->der), &punt_aux);
      
    free(punt_aux);         
  } /* else */
} /* borrar_clave_recur */

int borrar_clave(nodo_arbol **punt_a_buscar, tipo_clave a_borrar) {
nodo_arbol *punt_aux;

  while (*punt_a_buscar != NULL) {
    if ((*punt_a_buscar)->clave == a_borrar) { /* Encontrada clave a borrar */
      punt_aux = *punt_a_buscar;
      /* Mirar si tiene un hijo */
      if ((*punt_a_buscar)->izq == NULL)
        *punt_a_buscar = (*punt_a_buscar)->der;      
      else if ((*punt_a_buscar)->der == NULL)
        *punt_a_buscar = (*punt_a_buscar)->izq;
      else /* ((*punt_a_buscar)->der != NULL) */ { /* Buscamos clave menor de las mayores */
        punt_a_buscar = &((*punt_a_buscar)->der);
        while ((*punt_a_buscar)->izq != NULL)
          punt_a_buscar = &((*punt_a_buscar)->izq);
        punt_aux->clave = (*punt_a_buscar)->clave;
        punt_aux = *punt_a_buscar;
        *punt_a_buscar = (*punt_a_buscar)->der;
      } /* else */
      free(punt_aux);
      return 1;                                                   
    } /* if ... */
    else if ((*punt_a_buscar)->clave < a_borrar)
      punt_a_buscar = &((*punt_a_buscar)->der);
    else /* ((*punt_a_buscar)->clave > a_borrar) */
      punt_a_buscar = &((*punt_a_buscar)->izq);              
  } /* while */
  return 0;
} /* borrar_clave */

void imprime_inorden(nodo_arbol *punt_recorrer, int margen) {
int i;
  if (punt_recorrer != NULL) {
    imprime_inorden(punt_recorrer->izq, margen+1);
    for (i = 0; i < margen; i++)
      printf("   ");
    printf("%d\n", punt_recorrer->clave);
    imprime_inorden(punt_recorrer->der, margen+1);                    
  } /* if ... */    
} /* imprime_inorden */


